import { Injectable } from '@angular/core';

import * as Electron from 'electron';

@Injectable({
  providedIn: 'root'
})
export class ElectronProxyService {
  constructor() {}

  /**
   * determines if SPA is running in Electron
   */
  public get isElectronApp(): boolean {
    return !!window.navigator.userAgent.match(/Electron/);
  }

  public get isMacOS(): boolean {
    return this.isElectronApp && process.platform === 'darwin';
  }

  public get isWindows(): boolean {
    return this.isElectronApp && process.platform === 'win32';
  }

  public get isLinux(): boolean {
    return this.isElectronApp && process.platform === 'linux';
  }

  public get isX86(): boolean {
    return this.isElectronApp && process.arch === 'ia32';
  }

  public get isX64(): boolean {
    return this.isElectronApp && process.arch === 'x64';
  }

  public get ipcRenderer(): Electron.IpcRenderer {
    return Electron.ipcRenderer;
  }

  // public get desktopCapturer(): Electron.DesktopCapturer {
  //   return Electron.desktopCapturer;
  // }

  // public get remote(): Electron.Remote {
  //   return Electron.remote;
  // }

  // public get webFrame(): Electron.WebFrame {
  //   return Electron.webFrame;
  // }

  // public get clipboard(): Electron.Clipboard {
  //   return Electron.clipboard;
  // }

  // public get crashReporter(): Electron.CrashReporter {
  //   return Electron.crashReporter;
  // }

  // public get process(): any {
  //   return this.remote ? this.remote.process : null;
  // }

  // public get nativeImage(): typeof Electron.nativeImage {
  //   return Electron.nativeImage;
  // }

  // public get screen(): Electron.Screen {
  //   return Electron.screen;
  // }

  // public get shell(): Electron.Shell {
  //   return Electron.shell;
  // }
}
